Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| xmlgraphics-commons 1.5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xmlgraphics.java2d
Class AbstractGraphics2D

    java.lang.Object
      java.awt.Graphics
          java.awt.Graphics2D
              org.apache.xmlgraphics.java2d.AbstractGraphics2D

All Implemented Interfaces:
  Cloneable

Direct Known Subclasses:
  DefaultGraphics2D, PSGraphics2D

    public abstract class AbstractGraphics2D

extends Graphics2D
implements Cloneable

This extension of the `java.awt.Graphics2D` abstract class is still abstract, but it implements a lot of the `Graphics2D` method in a way that concrete implementations can reuse. This class uses a `GraphicContext` to store the state of its various attributes that control the rendering, such as the current `Font`, `Paint` or clip. Concrete implementations can focus on implementing the rendering methods, such as `drawShape`. As a convenience, rendering methods that can be expressed with other rendering methods (e.g., `drawRect` can be expressed as `draw(new Rectangle(..))`), are implemented by `AbstractGraphics2D`

Version:
  $Id: AbstractGraphics2D.java 1345683 2012-06-03 14:50:33Z gadams $
See Also:
  `Originally authored by Vincent Hardy.`

Field Summary
`protected GraphicContext` | `gc` Current state of the Graphic Context.
`protected boolean` | `inPossibleRecursion` Protection agains infinite recursion
`protected boolean` | `textAsShapes` Text handling strategy.

Constructor Summary
`AbstractGraphics2D(AbstractGraphics2D g)` Creates a new AbstractGraphics2D from an existing instance.
`AbstractGraphics2D(boolean textAsShapes)`

Method Summary
`void` | `addRenderingHints(Map hints)` Sets the values of an arbitrary number of preferences for the rendering algorithms.
`void` | `clearRect(int x, int y, int width, int height)` Clears the specified rectangle by filling it with the background color of the current drawing surface.
`void` | `clip(Shape s)` Intersects the current `Clip` with the interior of the specified `Shape` and sets the `Clip` to the resulting intersection.
`void` | `clipRect(int x, int y, int width, int height)` Intersects the current clip with the specified rectangle.
`void` | `drawArc(int x, int y, int width, int height, int startAngle, int arcAngle)` Draws the outline of a circular or elliptical arc covering the specified rectangle.
`void` | `drawGlyphVector(GlyphVector g, float x, float y)` Renders the text of the specified `GlyphVector` using the `Graphics2D` context's rendering attributes.
`void` | `drawImage(BufferedImage img, BufferedImageOp op, int x, int y)` Renders a `BufferedImage` that is filtered with a `BufferedImageOp`.
`boolean` | `drawImage(Image img, AffineTransform xform, ImageObserver obs)` Renders an image, applying a transform from image space into user space before drawing.
`boolean` | `drawImage(Image img, int x, int y, Color bgcolor, ImageObserver observer)` Draws as much of the specified image as is currently available.
`boolean` | `drawImage(Image img, int x, int y, int width, int height, Color bgcolor, ImageObserver observer)` Draws as much of the specified image as has already been scaled to fit inside the specified rectangle.
`boolean` | `drawImage(Image img, int dx1, int dy1, int dx2, int dy2, int sx1, int sy1, int sx2, int sy2, Color bgcolor, ImageObserver observer)` Draws as much of the specified area of the specified image as is currently available, scaling it on the fly to fit inside the specified area of the destination drawable surface.
`boolean` | `drawImage(Image img, int dx1, int dy1, int dx2, int dy2, int sx1, int sy1, int sx2, int sy2, ImageObserver observer)` Draws as much of the specified area of the specified image as is currently available, scaling it on the fly to fit inside the specified area of the destination drawable surface.
`void` | `drawLine(int x1, int y1, int x2, int y2)` Draws a line, using the current color, between the points `(x1, y1)` and `(x2, y2)` in this graphics context's coordinate system.
`void` | `drawOval(int x, int y, int width, int height)` Draws the outline of an oval.
`void` | `drawPolygon(int[] xPoints, int[] yPoints, int nPoints)` Draws a closed polygon defined by arrays of x and y coordinates.
`void` | `drawPolyline(int[] xPoints, int[] yPoints, int nPoints)` Draws a sequence of connected lines defined by arrays of x and y coordinates.
`void` | `drawRect(int x, int y, int width, int height)`
`void` | `drawRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight)` Draws an outlined round-cornered rectangle using this graphics context's current color.
`void` | `drawString(AttributedCharacterIterator iterator, float x, float y)` Generic implementation for drawing attributed strings using TextLayout.
`void` | `drawString(AttributedCharacterIterator iterator, int x, int y)` Draws the text given by the specified iterator, using this graphics context's current color.
`void` | `drawString(String str, int x, int y)` Draws the text given by the specified string, using this graphics context's current font and color.
`void` | `fillArc(int x, int y, int width, int height, int startAngle, int arcAngle)` Fills a circular or elliptical arc covering the specified rectangle.
`void` | `fillOval(int x, int y, int width, int height)` Fills an oval bounded by the specified rectangle with the current color.
`void` | `fillPolygon(int[] xPoints, int[] yPoints, int nPoints)` Fills a closed polygon defined by arrays of x and y coordinates.
`void` | `fillRect(int x, int y, int width, int height)` Fills the specified rectangle.
`void` | `fillRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight)` Fills the specified rounded corner rectangle with the current color.
`Color` | `getBackground()` Returns the background color used for clearing a region.
`Shape` | `getClip()` Gets the current clipping area.
`Rectangle` | `getClipBounds()` Returns the bounding rectangle of the current clipping area.
`Color` | `getColor()` Gets this graphics context's current color.
`Composite` | `getComposite()` Returns the current `Composite` in the `Graphics2D` context.
`Font` | `getFont()` Gets the current font.
`FontRenderContext` | `getFontRenderContext()` Get the rendering context of the `Font` within this `Graphics2D` context.
`GraphicContext` | `getGraphicContext()`
`Paint` | `getPaint()` Returns the current `Paint` of the `Graphics2D` context.
`Object` | `getRenderingHint(RenderingHints.Key hintKey)` Returns the value of a single preference for the rendering algorithms.
`RenderingHints` | `getRenderingHints()` Gets the preferences for the rendering algorithms.
`Stroke` | `getStroke()` Returns the current `Stroke` in the `Graphics2D` context.
`AffineTransform` | `getTransform()` Returns a copy of the current `Transform` in the `Graphics2D` context.
`boolean` | `hit(Rectangle rect, Shape s, boolean onStroke)` Checks whether or not the specified `Shape` intersects the specified `Rectangle`, which is in device space.
`void` | `rotate(double theta)` Concatenates the current `Graphics2D` `Transform` with a rotation transform.
`void` | `rotate(double theta, double x, double y)` Concatenates the current `Graphics2D` `Transform` with a translated rotation transform.
`void` | `scale(double sx, double sy)` Concatenates the current `Graphics2D` `Transform` with a scaling transformation Subsequent rendering is resized according to the specified scaling factors relative to the previous scaling.
`void` | `setBackground(Color color)` Sets the background color for the `Graphics2D` context.
`void` | `setClip(int x, int y, int width, int height)` Sets the current clip to the rectangle specified by the given coordinates.
`void` | `setClip(Shape clip)` Sets the current clipping area to an arbitrary clip shape.
`void` | `setColor(Color c)` Sets this graphics context's current color to the specified color.
`void` | `setComposite(Composite comp)` Sets the `Composite` for the `Graphics2D` context.
`void` | `setFont(Font font)` Sets this graphics context's font to the specified font.
`void` | `setPaint(Paint paint)` Sets the `Paint` attribute for the `Graphics2D` context.
`void` | `setPaintMode()` Sets the paint mode of this graphics context to overwrite the destination with this graphics context's current color.
`void` | `setRenderingHint(RenderingHints.Key hintKey, Object hintValue)` Sets the value of a single preference for the rendering algorithms.
`void` | `setRenderingHints(Map hints)` Replaces the values of all preferences for the rendering algorithms with the specified `hints`.
`void` | `setStroke(Stroke s)` Sets the `Stroke` for the `Graphics2D` context.
`void` | `setTransform(AffineTransform Tx)` Sets the `Transform` in the `Graphics2D` context.
`void` | `shear(double shx, double shy)` Concatenates the current `Graphics2D` `Transform` with a shearing transform.
`void` | `transform(AffineTransform Tx)` Composes an `AffineTransform` object with the `Transform` in this `Graphics2D` according to the rule last-specified-first-applied.
`void` | `translate(double tx, double ty)` Concatenates the current `Graphics2D` `Transform` with a translation transform.
`void` | `translate(int x, int y)` Translates the origin of the graphics context to the point (x, y) in the current coordinate system.

Methods inherited from class java.awt.Graphics2D
`draw, draw3DRect, drawRenderableImage, drawRenderedImage, drawString, fill, fill3DRect, getDeviceConfiguration`

Methods inherited from class java.awt.Graphics
`copyArea, create, create, dispose, drawBytes, drawChars, drawImage, drawImage, drawPolygon, fillPolygon, finalize, getClipBounds, getClipRect, getFontMetrics, getFontMetrics, hitClip, setXORMode, toString`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### gc

    protected GraphicContext gc

  Current state of the Graphic Context. The GraphicsContext class manages the state of this `Graphics2D` graphic context attributes.

### textAsShapes

    protected boolean textAsShapes

  Text handling strategy.

### inPossibleRecursion

    protected boolean inPossibleRecursion

  Protection agains infinite recursion

Constructor Detail

### AbstractGraphics2D

    public AbstractGraphics2D(boolean textAsShapes)

Parameters:
  `textAsShapes` - if true, all text is turned into shapes in the convertion. No text is output.

### AbstractGraphics2D

    public AbstractGraphics2D(AbstractGraphics2D g)

  Creates a new AbstractGraphics2D from an existing instance.

  Parameters:
    `g` - the AbstractGraphics2D whose properties should be copied

Method Detail

### translate

    public void translate(int x,
                          int y)

  Translates the origin of the graphics context to the point (x, y) in the current coordinate system. Modifies this graphics context so that its new origin corresponds to the point (x, y) in this graphics context's original coordinate system. All coordinates used in subsequent rendering operations on this graphics context will be relative to this new origin.

  Specified by:
    `translate` in class `Graphics2D`
  Parameters:
    `x` - the x coordinate.
    `y` - the y coordinate.

### getColor

    public Color getColor()

  Gets this graphics context's current color.

  Specified by:
    `getColor` in class `Graphics`
  Returns:
    this graphics context's current color.
  See Also:
    `Color`, `Graphics.setColor(java.awt.Color)`

### setColor

    public void setColor(Color c)

  Sets this graphics context's current color to the specified color. All subsequent graphics operations using this graphics context use this specified color.

  Specified by:
    `setColor` in class `Graphics`
  Parameters:
    `c` - the new rendering color.
  See Also:
    `Color`, `Graphics.getColor()`

### setPaintMode

    public void setPaintMode()

  Sets the paint mode of this graphics context to overwrite the destination with this graphics context's current color. This sets the logical pixel operation function to the paint or overwrite mode. All subsequent rendering operations will overwrite the destination with the current color.

  Specified by:
    `setPaintMode` in class `Graphics`

### getFont

    public Font getFont()

  Gets the current font.

  Specified by:
    `getFont` in class `Graphics`
  Returns:
    this graphics context's current font.
  See Also:
    `Font`, `Graphics.setFont(java.awt.Font)`

### setFont

    public void setFont(Font font)

  Sets this graphics context's font to the specified font. All subsequent text operations using this graphics context use this font.

  Specified by:
    `setFont` in class `Graphics`
  Parameters:
    `font` - the font.
  See Also:
    `Graphics.getFont()`

### getClipBounds

    public Rectangle getClipBounds()

  Returns the bounding rectangle of the current clipping area. This method refers to the user clip, which is independent of the clipping associated with device bounds and window visibility. If no clip has previously been set, or if the clip has been cleared using `setClip(null)`, this method returns `null`. The coordinates in the rectangle are relative to the coordinate system origin of this graphics context.

  Specified by:
    `getClipBounds` in class `Graphics`
  Returns:
    the bounding rectangle of the current clipping area, or `null` if no clip is set.
  Since:
    JDK1.1
  See Also:
    `Graphics.getClip()`, `Graphics.clipRect(int, int, int, int)`, `Graphics.setClip(int, int, int, int)`, `Graphics.setClip(Shape)`

### clipRect

    public void clipRect(int x,
                         int y,
                         int width,
                         int height)

  Intersects the current clip with the specified rectangle. The resulting clipping area is the intersection of the current clipping area and the specified rectangle. If there is no current clipping area, either because the clip has never been set, or the clip has been cleared using `setClip(null)`, the specified rectangle becomes the new clip. This method sets the user clip, which is independent of the clipping associated with device bounds and window visibility. This method can only be used to make the current clip smaller. To set the current clip larger, use any of the setClip methods. Rendering operations have no effect outside of the clipping area.

  Specified by:
    `clipRect` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the rectangle to intersect the clip with
    `y` - the y coordinate of the rectangle to intersect the clip with
    `width` - the width of the rectangle to intersect the clip with
    `height` - the height of the rectangle to intersect the clip with
  See Also:
    `setClip(int, int, int, int)`, `setClip(Shape)`

### setClip

    public void setClip(int x,
                        int y,
                        int width,
                        int height)

  Sets the current clip to the rectangle specified by the given coordinates. This method sets the user clip, which is independent of the clipping associated with device bounds and window visibility. Rendering operations have no effect outside of the clipping area.

  Specified by:
    `setClip` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the new clip rectangle.
    `y` - the y coordinate of the new clip rectangle.
    `width` - the width of the new clip rectangle.
    `height` - the height of the new clip rectangle.
  Since:
    JDK1.1
  See Also:
    `Graphics.clipRect(int, int, int, int)`, `Graphics.setClip(Shape)`

### getClip

    public Shape getClip()

  Gets the current clipping area. This method returns the user clip, which is independent of the clipping associated with device bounds and window visibility. If no clip has previously been set, or if the clip has been cleared using `setClip(null)`, this method returns `null`.

  Specified by:
    `getClip` in class `Graphics`
  Returns:
    a `Shape` object representing the current clipping area, or `null` if no clip is set.
  Since:
    JDK1.1
  See Also:
    `Graphics.getClipBounds()`, `Graphics.clipRect(int, int, int, int)`, `Graphics.setClip(int, int, int, int)`, `Graphics.setClip(Shape)`

### setClip

    public void setClip(Shape clip)

  Sets the current clipping area to an arbitrary clip shape. Not all objects that implement the `Shape` interface can be used to set the clip. The only `Shape` objects that are guaranteed to be supported are `Shape` objects that are obtained via the `getClip` method and via `Rectangle` objects. This method sets the user clip, which is independent of the clipping associated with device bounds and window visibility.

  Specified by:
    `setClip` in class `Graphics`
  Parameters:
    `clip` - the `Shape` to use to set the clip
  Since:
    JDK1.1
  See Also:
    `Graphics.getClip()`, `Graphics.clipRect(int, int, int, int)`, `Graphics.setClip(int, int, int, int)`

### drawLine

    public void drawLine(int x1,
                         int y1,
                         int x2,
                         int y2)

  Draws a line, using the current color, between the points `(x1, y1)` and `(x2, y2)` in this graphics context's coordinate system.

  Specified by:
    `drawLine` in class `Graphics`
  Parameters:
    `x1` - the first point's x coordinate.
    `y1` - the first point's y coordinate.
    `x2` - the second point's x coordinate.
    `y2` - the second point's y coordinate.

### fillRect

    public void fillRect(int x,
                         int y,
                         int width,
                         int height)

  Fills the specified rectangle. The left and right edges of the rectangle are at `x` and `x + width - 1`. The top and bottom edges are at `y` and `y + height - 1`. The resulting rectangle covers an area `width` pixels wide by `height` pixels tall. The rectangle is filled using the graphics context's current color.

  Specified by:
    `fillRect` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the rectangle to be filled.
    `y` - the y coordinate of the rectangle to be filled.
    `width` - the width of the rectangle to be filled.
    `height` - the height of the rectangle to be filled.
  See Also:
    `Graphics.clearRect(int, int, int, int)`, `Graphics.drawRect(int, int, int, int)`

### drawRect

    public void drawRect(int x,
                         int y,
                         int width,
                         int height)

  Overrides:
    `drawRect` in class `Graphics`

### clearRect

    public void clearRect(int x,
                          int y,
                          int width,
                          int height)

  Clears the specified rectangle by filling it with the background color of the current drawing surface. This operation does not use the current paint mode.

  Beginning with Java 1.1, the background color of offscreen images may be system dependent. Applications should use `setColor` followed by `fillRect` to ensure that an offscreen image is cleared to a specific color.

  Specified by:
    `clearRect` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the rectangle to clear.
    `y` - the y coordinate of the rectangle to clear.
    `width` - the width of the rectangle to clear.
    `height` - the height of the rectangle to clear.
  See Also:
    `Graphics.fillRect(int, int, int, int)`, `Graphics.drawRect(int, int, int, int)`, `Graphics.setColor(java.awt.Color)`, `Graphics.setPaintMode()`, `Graphics.setXORMode(java.awt.Color)`

### drawRoundRect

    public void drawRoundRect(int x,
                              int y,
                              int width,
                              int height,
                              int arcWidth,
                              int arcHeight)

  Draws an outlined round-cornered rectangle using this graphics context's current color. The left and right edges of the rectangle are at `x` and `x + width`, respectively. The top and bottom edges of the rectangle are at `y` and `y + height`.

  Specified by:
    `drawRoundRect` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the rectangle to be drawn.
    `y` - the y coordinate of the rectangle to be drawn.
    `width` - the width of the rectangle to be drawn.
    `height` - the height of the rectangle to be drawn.
    `arcWidth` - the horizontal diameter of the arc at the four corners.
    `arcHeight` - the vertical diameter of the arc at the four corners.
  See Also:
    `Graphics.fillRoundRect(int, int, int, int, int, int)`

### fillRoundRect

    public void fillRoundRect(int x,
                              int y,
                              int width,
                              int height,
                              int arcWidth,
                              int arcHeight)

  Fills the specified rounded corner rectangle with the current color. The left and right edges of the rectangle are at `x` and `x + width - 1`, respectively. The top and bottom edges of the rectangle are at `y` and `y + height - 1`.

  Specified by:
    `fillRoundRect` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the rectangle to be filled.
    `y` - the y coordinate of the rectangle to be filled.
    `width` - the width of the rectangle to be filled.
    `height` - the height of the rectangle to be filled.
    `arcWidth` - the horizontal diameter of the arc at the four corners.
    `arcHeight` - the vertical diameter of the arc at the four corners.
  See Also:
    `Graphics.drawRoundRect(int, int, int, int, int, int)`

### drawOval

    public void drawOval(int x,
                         int y,
                         int width,
                         int height)

  Draws the outline of an oval. The result is a circle or ellipse that fits within the rectangle specified by the `x`, `y`, `width`, and `height` arguments.

  The oval covers an area that is `width + 1` pixels wide and `height + 1` pixels tall.

  Specified by:
    `drawOval` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the upper left corner of the oval to be drawn.
    `y` - the y coordinate of the upper left corner of the oval to be drawn.
    `width` - the width of the oval to be drawn.
    `height` - the height of the oval to be drawn.
  See Also:
    `Graphics.fillOval(int, int, int, int)`

### fillOval

    public void fillOval(int x,
                         int y,
                         int width,
                         int height)

  Fills an oval bounded by the specified rectangle with the current color.

  Specified by:
    `fillOval` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the upper left corner of the oval to be filled.
    `y` - the y coordinate of the upper left corner of the oval to be filled.
    `width` - the width of the oval to be filled.
    `height` - the height of the oval to be filled.
  See Also:
    `Graphics.drawOval(int, int, int, int)`

### drawArc

    public void drawArc(int x,
                        int y,
                        int width,
                        int height,
                        int startAngle,
                        int arcAngle)

  Draws the outline of a circular or elliptical arc covering the specified rectangle.

  The resulting arc begins at `startAngle` and extends for `arcAngle` degrees, using the current color. Angles are interpreted such that 0 degrees is at the 3 o'clock position. A positive value indicates a counter-clockwise rotation while a negative value indicates a clockwise rotation.

  The center of the arc is the center of the rectangle whose origin is (x, y) and whose size is specified by the `width` and `height` arguments.

  The resulting arc covers an area `width + 1` pixels wide by `height + 1` pixels tall.

  The angles are specified relative to the non-square extents of the bounding rectangle such that 45 degrees always falls on the line from the center of the ellipse to the upper right corner of the bounding rectangle. As a result, if the bounding rectangle is noticeably longer in one axis than the other, the angles to the start and end of the arc segment will be skewed farther along the longer axis of the bounds.

  Specified by:
    `drawArc` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the upper-left corner of the arc to be drawn.
    `y` - the y coordinate of the upper-left corner of the arc to be drawn.
    `width` - the width of the arc to be drawn.
    `height` - the height of the arc to be drawn.
    `startAngle` - the beginning angle.
    `arcAngle` - the angular extent of the arc, relative to the start angle.
  See Also:
    `Graphics.fillArc(int, int, int, int, int, int)`

### fillArc

    public void fillArc(int x,
                        int y,
                        int width,
                        int height,
                        int startAngle,
                        int arcAngle)

  Fills a circular or elliptical arc covering the specified rectangle.

  The resulting arc begins at `startAngle` and extends for `arcAngle` degrees. Angles are interpreted such that 0 degrees is at the 3 o'clock position. A positive value indicates a counter-clockwise rotation while a negative value indicates a clockwise rotation.

  The center of the arc is the center of the rectangle whose origin is (x, y) and whose size is specified by the `width` and `height` arguments.

  The resulting arc covers an area `width + 1` pixels wide by `height + 1` pixels tall.

  The angles are specified relative to the non-square extents of the bounding rectangle such that 45 degrees always falls on the line from the center of the ellipse to the upper right corner of the bounding rectangle. As a result, if the bounding rectangle is noticeably longer in one axis than the other, the angles to the start and end of the arc segment will be skewed farther along the longer axis of the bounds.

  Specified by:
    `fillArc` in class `Graphics`
  Parameters:
    `x` - the x coordinate of the upper-left corner of the arc to be filled.
    `y` - the y coordinate of the upper-left corner of the arc to be filled.
    `width` - the width of the arc to be filled.
    `height` - the height of the arc to be filled.
    `startAngle` - the beginning angle.
    `arcAngle` - the angular extent of the arc, relative to the start angle.
  See Also:
    `Graphics.drawArc(int, int, int, int, int, int)`

### drawPolyline

    public void drawPolyline(int[] xPoints,
                             int[] yPoints,
                             int nPoints)

  Draws a sequence of connected lines defined by arrays of x and y coordinates. Each pair of (x, y) coordinates defines a point. The figure is not closed if the first point differs from the last point.

  Specified by:
    `drawPolyline` in class `Graphics`
  Parameters:
    `xPoints` - an array of x points
    `yPoints` - an array of y points
    `nPoints` - the total number of points
  Since:
    JDK1.1
  See Also:
    `Graphics.drawPolygon(int[], int[], int)`

### drawPolygon

    public void drawPolygon(int[] xPoints,
                            int[] yPoints,
                            int nPoints)

  Draws a closed polygon defined by arrays of x and y coordinates. Each pair of (x, y) coordinates defines a point.

  This method draws the polygon defined by `nPoint` line segments, where the first `nPoint - 1` line segments are line segments from `(xPoints[i - 1], yPoints[i - 1])` to `(xPoints[i], yPoints[i])`, for 1 ≤ i ≤ `nPoints`. The figure is automatically closed by drawing a line connecting the final point to the first point, if those points are different.

  Specified by:
    `drawPolygon` in class `Graphics`
  Parameters:
    `xPoints` - a an array of `x` coordinates.
    `yPoints` - a an array of `y` coordinates.
    `nPoints` - a the total number of points.
  See Also:
    `Graphics.fillPolygon(int[],int[],int)`, `Graphics.drawPolyline(int[], int[], int)`

### fillPolygon

    public void fillPolygon(int[] xPoints,
                            int[] yPoints,
                            int nPoints)

  Fills a closed polygon defined by arrays of x and y coordinates.

  This method draws the polygon defined by `nPoint` line segments, where the first `nPoint - 1` line segments are line segments from `(xPoints[i - 1], yPoints[i - 1])` to `(xPoints[i], yPoints[i])`, for 1 ≤ i ≤ `nPoints`. The figure is automatically closed by drawing a line connecting the final point to the first point, if those points are different.

  The area inside the polygon is defined using an even-odd fill rule, also known as the alternating rule.

  Specified by:
    `fillPolygon` in class `Graphics`
  Parameters:
    `xPoints` - a an array of `x` coordinates.
    `yPoints` - a an array of `y` coordinates.
    `nPoints` - a the total number of points.
  See Also:
    `Graphics.drawPolygon(int[], int[], int)`

### drawString

    public void drawString(String str,
                           int x,
                           int y)

  Draws the text given by the specified string, using this graphics context's current font and color. The baseline of the first character is at position (x, y) in this graphics context's coordinate system.

  Specified by:
    `drawString` in class `Graphics2D`
  Parameters:
    `str` - the string to be drawn.
    `x` - the x coordinate.
    `y` - the y coordinate.
  See Also:
    `Graphics.drawBytes(byte[], int, int, int, int)`, `Graphics.drawChars(char[], int, int, int, int)`

### drawString

    public void drawString(AttributedCharacterIterator iterator,
                           float x,
                           float y)

  Generic implementation for drawing attributed strings using TextLayout.

  Specified by:
    `drawString` in class `Graphics2D`
  Parameters:
    `iterator` - the iterator whose text is to be rendered
    `x` - the x coordinate where the iterator's text is to be rendered
    `y` - the y coordinate where the iterator's text is to be rendered
  See Also:
    `(java.text.AttributedCharacterIterator, float, float)`

### drawString

    public void drawString(AttributedCharacterIterator iterator,
                           int x,
                           int y)

  Draws the text given by the specified iterator, using this graphics context's current color. The iterator has to specify a font for each character. The baseline of the first character is at position (x, y) in this graphics context's coordinate system.

  Specified by:
    `drawString` in class `Graphics2D`
  Parameters:
    `iterator` - the iterator whose text is to be drawn
    `x` - the x coordinate.
    `y` - the y coordinate.
  See Also:
    `Graphics.drawBytes(byte[], int, int, int, int)`, `Graphics.drawChars(char[], int, int, int, int)`

### drawImage

    public boolean drawImage(Image img,
                             int x,
                             int y,
                             Color bgcolor,
                             ImageObserver observer)

  Draws as much of the specified image as is currently available. The image is drawn with its top-left corner at (x, y) in this graphics context's coordinate space. Transparent pixels are drawn in the specified background color.

  This operation is equivalent to filling a rectangle of the width and height of the specified image with the given color and then drawing the image on top of it, but possibly more efficient.

  This method returns immediately in all cases, even if the complete image has not yet been loaded, and it has not been dithered and converted for the current output device.

  If the image has not yet been completely loaded, then `drawImage` returns `false`. As more of the image becomes available, the process that draws the image notifies the specified image observer.

  Specified by:
    `drawImage` in class `Graphics`
  Parameters:
    `img` - the specified image to be drawn.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `bgcolor` - the background color to paint under the non-opaque portions of the image.
    `observer` - object to be notified as more of the image is converted.
  See Also:
    `Image`, `ImageObserver`, `ImageObserver.imageUpdate(java.awt.Image, int, int, int, int, int)`

### drawImage

    public boolean drawImage(Image img,
                             int x,
                             int y,
                             int width,
                             int height,
                             Color bgcolor,
                             ImageObserver observer)

  Draws as much of the specified image as has already been scaled to fit inside the specified rectangle.

  The image is drawn inside the specified rectangle of this graphics context's coordinate space, and is scaled if necessary. Transparent pixels are drawn in the specified background color. This operation is equivalent to filling a rectangle of the width and height of the specified image with the given color and then drawing the image on top of it, but possibly more efficient.

  This method returns immediately in all cases, even if the entire image has not yet been scaled, dithered, and converted for the current output device. If the current output representation is not yet complete then `drawImage` returns `false`. As more of the image becomes available, the process that draws the image notifies the specified image observer.

  A scaled version of an image will not necessarily be available immediately just because an unscaled version of the image has been constructed for this output device. Each size of the image may be cached separately and generated from the original data in a separate image production sequence.

  Specified by:
    `drawImage` in class `Graphics`
  Parameters:
    `img` - the specified image to be drawn.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `width` - the width of the rectangle.
    `height` - the height of the rectangle.
    `bgcolor` - the background color to paint under the non-opaque portions of the image.
    `observer` - object to be notified as more of the image is converted.
  See Also:
    `Image`, `ImageObserver`, `ImageObserver.imageUpdate(java.awt.Image, int, int, int, int, int)`

### drawImage

    public boolean drawImage(Image img,
                             int dx1,
                             int dy1,
                             int dx2,
                             int dy2,
                             int sx1,
                             int sy1,
                             int sx2,
                             int sy2,
                             ImageObserver observer)

  Draws as much of the specified area of the specified image as is currently available, scaling it on the fly to fit inside the specified area of the destination drawable surface. Transparent pixels do not affect whatever pixels are already there.

  This method returns immediately in all cases, even if the image area to be drawn has not yet been scaled, dithered, and converted for the current output device. If the current output representation is not yet complete then `drawImage` returns `false`. As more of the image becomes available, the process that draws the image notifies the specified image observer.

  This method always uses the unscaled version of the image to render the scaled rectangle and performs the required scaling on the fly. It does not use a cached, scaled version of the image for this operation. Scaling of the image from source to destination is performed such that the first coordinate of the source rectangle is mapped to the first coordinate of the destination rectangle, and the second source coordinate is mapped to the second destination coordinate. The subimage is scaled and flipped as needed to preserve those mappings.

  Specified by:
    `drawImage` in class `Graphics`
  Parameters:
    `img` - the specified image to be drawn
    `dx1` - the x coordinate of the first corner of the destination rectangle.
    `dy1` - the y coordinate of the first corner of the destination rectangle.
    `dx2` - the x coordinate of the second corner of the destination rectangle.
    `dy2` - the y coordinate of the second corner of the destination rectangle.
    `sx1` - the x coordinate of the first corner of the source rectangle.
    `sy1` - the y coordinate of the first corner of the source rectangle.
    `sx2` - the x coordinate of the second corner of the source rectangle.
    `sy2` - the y coordinate of the second corner of the source rectangle.
    `observer` - object to be notified as more of the image is scaled and converted.
  Since:
    JDK1.1
  See Also:
    `Image`, `ImageObserver`, `ImageObserver.imageUpdate(java.awt.Image, int, int, int, int, int)`

### drawImage

    public boolean drawImage(Image img,
                             int dx1,
                             int dy1,
                             int dx2,
                             int dy2,
                             int sx1,
                             int sy1,
                             int sx2,
                             int sy2,
                             Color bgcolor,
                             ImageObserver observer)

  Draws as much of the specified area of the specified image as is currently available, scaling it on the fly to fit inside the specified area of the destination drawable surface.

  Transparent pixels are drawn in the specified background color. This operation is equivalent to filling a rectangle of the width and height of the specified image with the given color and then drawing the image on top of it, but possibly more efficient.

  This method returns immediately in all cases, even if the image area to be drawn has not yet been scaled, dithered, and converted for the current output device. If the current output representation is not yet complete then `drawImage` returns `false`. As more of the image becomes available, the process that draws the image notifies the specified image observer.

  This method always uses the unscaled version of the image to render the scaled rectangle and performs the required scaling on the fly. It does not use a cached, scaled version of the image for this operation. Scaling of the image from source to destination is performed such that the first coordinate of the source rectangle is mapped to the first coordinate of the destination rectangle, and the second source coordinate is mapped to the second destination coordinate. The subimage is scaled and flipped as needed to preserve those mappings.

  Specified by:
    `drawImage` in class `Graphics`
  Parameters:
    `img` - the specified image to be drawn
    `dx1` - the x coordinate of the first corner of the destination rectangle.
    `dy1` - the y coordinate of the first corner of the destination rectangle.
    `dx2` - the x coordinate of the second corner of the destination rectangle.
    `dy2` - the y coordinate of the second corner of the destination rectangle.
    `sx1` - the x coordinate of the first corner of the source rectangle.
    `sy1` - the y coordinate of the first corner of the source rectangle.
    `sx2` - the x coordinate of the second corner of the source rectangle.
    `sy2` - the y coordinate of the second corner of the source rectangle.
    `bgcolor` - the background color to paint under the non-opaque portions of the image.
    `observer` - object to be notified as more of the image is scaled and converted.
  Since:
    JDK1.1
  See Also:
    `Image`, `ImageObserver`, `ImageObserver.imageUpdate(java.awt.Image, int, int, int, int, int)`

### drawImage

    public boolean drawImage(Image img,
                             AffineTransform xform,
                             ImageObserver obs)

  Renders an image, applying a transform from image space into user space before drawing. The transformation from user space into device space is done with the current `Transform` in the `Graphics2D`. The specified transformation is applied to the image before the transform attribute in the `Graphics2D` context is applied. The rendering attributes applied include the `Clip`, `Transform`, and `Composite` attributes. Note that no rendering is done if the specified transform is noninvertible.

  Specified by:
    `drawImage` in class `Graphics2D`
  Parameters:
    `img` - the `Image` to be rendered
    `xform` - the transformation from image space into user space
    `obs` - the `ImageObserver` to be notified as more of the `Image` is converted
  Returns:
    `true` if the `Image` is fully loaded and completely rendered; `false` if the `Image` is still being loaded.
  See Also:
    `transform(java.awt.geom.AffineTransform)`, `setTransform(java.awt.geom.AffineTransform)`, `setComposite(java.awt.Composite)`, `clip(java.awt.Shape)`, `setClip(Shape)`

### drawImage

    public void drawImage(BufferedImage img,
                          BufferedImageOp op,
                          int x,
                          int y)

  Renders a `BufferedImage` that is filtered with a `BufferedImageOp`. The rendering attributes applied include the `Clip`, `Transform` and `Composite` attributes. This is equivalent to:

       img1 = op.filter(img, null);
       drawImage(img1, new AffineTransform(1f,0f,0f,1f,x,y), null);

  Specified by:
    `drawImage` in class `Graphics2D`
  Parameters:
    `img` - the `BufferedImage` to be rendered
    `op` - the filter to be applied to the image before rendering
    `x` - the x coordinate in user space where the image is rendered
    `y` - the y coordinate in user space where the image is rendered
  See Also:
    `transform(java.awt.geom.AffineTransform)`, `setTransform(java.awt.geom.AffineTransform)`, `setComposite(java.awt.Composite)`, `clip(java.awt.Shape)`, `setClip(Shape)`

### drawGlyphVector

    public void drawGlyphVector(GlyphVector g,
                                float x,
                                float y)

  Renders the text of the specified `GlyphVector` using the `Graphics2D` context's rendering attributes. The rendering attributes applied include the `Clip`, `Transform`, `Paint`, and `Composite` attributes. The `GlyphVector` specifies individual glyphs from a `Font`. The `GlyphVector` can also contain the glyph positions. This is the fastest way to render a set of characters to the screen.

  Specified by:
    `drawGlyphVector` in class `Graphics2D`
  Parameters:
    `g` - the `GlyphVector` to be rendered
    `x` - the x position in user space where the glyphs should be rendered
    `y` - the y position in user space where the glyphs should be rendered
  See Also:
    `Font.createGlyphVector(FontRenderContext, char[])`, `GlyphVector`, `setPaint(java.awt.Paint)`, `Graphics.setColor(java.awt.Color)`, `setTransform(java.awt.geom.AffineTransform)`, `setComposite(java.awt.Composite)`, `setClip(Shape)`

### hit

    public boolean hit(Rectangle rect,
                       Shape s,
                       boolean onStroke)

  Checks whether or not the specified `Shape` intersects the specified `Rectangle`, which is in device space. If `onStroke` is false, this method checks whether or not the interior of the specified `Shape` intersects the specified `Rectangle`. If `onStroke` is `true`, this method checks whether or not the `Stroke` of the specified `Shape` outline intersects the specified `Rectangle`. The rendering attributes taken into account include the `Clip`, `Transform`, and `Stroke` attributes.

  Specified by:
    `hit` in class `Graphics2D`
  Parameters:
    `rect` - the area in device space to check for a hit
    `s` - the `Shape` to check for a hit
    `onStroke` - flag used to choose between testing the stroked or the filled shape. If the flag is `true`, the `Stroke` oultine is tested. If the flag is `false`, the filled `Shape` is tested.
  Returns:
    `true` if there is a hit; `false` otherwise.
  See Also:
    `setStroke(java.awt.Stroke)`, `Graphics2D.fill(Shape)`, `Graphics2D.draw(Shape)`, `transform(java.awt.geom.AffineTransform)`, `setTransform(java.awt.geom.AffineTransform)`, `clip(java.awt.Shape)`, `setClip(Shape)`

### setComposite

    public void setComposite(Composite comp)

  Sets the `Composite` for the `Graphics2D` context. The `Composite` is used in all drawing methods such as `drawImage`, `drawString`, `draw`, and `fill`. It specifies how new pixels are to be combined with the existing pixels on the graphics device during the rendering process.

  If this `Graphics2D` context is drawing to a `Component` on the display screen and the `Composite` is a custom object rather than an instance of the `AlphaComposite` class, and if there is a security manager, its `checkPermission` method is called with an `AWTPermission("readDisplayPixels")` permission.

  Specified by:
    `setComposite` in class `Graphics2D`
  Parameters:
    `comp` - the `Composite` object to be used for rendering
  Throws:
    `SecurityException` - if a custom `Composite` object is being used to render to the screen and a security manager is set and its `checkPermission` method does not allow the operation.
  See Also:
    `Graphics.setXORMode(java.awt.Color)`, `Graphics.setPaintMode()`, `AlphaComposite`

### setPaint

    public void setPaint(Paint paint)

  Sets the `Paint` attribute for the `Graphics2D` context. Calling this method with a `null` `Paint` object does not have any effect on the current `Paint` attribute of this `Graphics2D`.

  Specified by:
    `setPaint` in class `Graphics2D`
  Parameters:
    `paint` - the `Paint` object to be used to generate color during the rendering process, or `null`
  See Also:
    `Graphics.setColor(java.awt.Color)`

### setStroke

    public void setStroke(Stroke s)

  Sets the `Stroke` for the `Graphics2D` context.

  Specified by:
    `setStroke` in class `Graphics2D`
  Parameters:
    `s` - the `Stroke` object to be used to stroke a `Shape` during the rendering process

### setRenderingHint

    public void setRenderingHint(RenderingHints.Key hintKey,
                                 Object hintValue)

  Sets the value of a single preference for the rendering algorithms. Hint categories include controls for rendering quality and overall time/quality trade-off in the rendering process. Refer to the `RenderingHints` class for definitions of some common keys and values.

  Specified by:
    `setRenderingHint` in class `Graphics2D`
  Parameters:
    `hintKey` - the key of the hint to be set.
    `hintValue` - the value indicating preferences for the specified hint category.
  See Also:
    `RenderingHints`

### getRenderingHint

    public Object getRenderingHint(RenderingHints.Key hintKey)

  Returns the value of a single preference for the rendering algorithms. Hint categories include controls for rendering quality and overall time/quality trade-off in the rendering process. Refer to the `RenderingHints` class for definitions of some common keys and values.

  Specified by:
    `getRenderingHint` in class `Graphics2D`
  Parameters:
    `hintKey` - the key corresponding to the hint to get.
  Returns:
    an object representing the value for the specified hint key. Some of the keys and their associated values are defined in the `RenderingHints` class.
  See Also:
    `RenderingHints`

### setRenderingHints

    public void setRenderingHints(Map hints)

  Replaces the values of all preferences for the rendering algorithms with the specified `hints`. The existing values for all rendering hints are discarded and the new set of known hints and values are initialized from the specified `Map` object. Hint categories include controls for rendering quality and overall time/quality trade-off in the rendering process. Refer to the `RenderingHints` class for definitions of some common keys and values.

  Specified by:
    `setRenderingHints` in class `Graphics2D`
  Parameters:
    `hints` - the rendering hints to be set
  See Also:
    `RenderingHints`

### addRenderingHints

    public void addRenderingHints(Map hints)

  Sets the values of an arbitrary number of preferences for the rendering algorithms. Only values for the rendering hints that are present in the specified `Map` object are modified. All other preferences not present in the specified object are left unmodified. Hint categories include controls for rendering quality and overall time/quality trade-off in the rendering process. Refer to the `RenderingHints` class for definitions of some common keys and values.

  Specified by:
    `addRenderingHints` in class `Graphics2D`
  Parameters:
    `hints` - the rendering hints to be set
  See Also:
    `RenderingHints`

### getRenderingHints

    public RenderingHints getRenderingHints()

  Gets the preferences for the rendering algorithms. Hint categories include controls for rendering quality and overall time/quality trade-off in the rendering process. Returns all of the hint key/value pairs that were ever specified in one operation. Refer to the `RenderingHints` class for definitions of some common keys and values.

  Specified by:
    `getRenderingHints` in class `Graphics2D`
  Returns:
    a reference to an instance of `RenderingHints` that contains the current preferences.
  See Also:
    `RenderingHints`

### translate

    public void translate(double tx,
                          double ty)

  Concatenates the current `Graphics2D` `Transform` with a translation transform. Subsequent rendering is translated by the specified distance relative to the previous position. This is equivalent to calling transform(T), where T is an `AffineTransform` represented by the following matrix:

                [   1    0    tx  ]
                [   0    1    ty  ]
                [   0    0    1   ]

  Specified by:
    `translate` in class `Graphics2D`
  Parameters:
    `tx` - the distance to translate along the x-axis
    `ty` - the distance to translate along the y-axis

### rotate

    public void rotate(double theta)

  Concatenates the current `Graphics2D` `Transform` with a rotation transform. Subsequent rendering is rotated by the specified radians relative to the previous origin. This is equivalent to calling `transform(R)`, where R is an `AffineTransform` represented by the following matrix:

                [   cos(theta)    -sin(theta)    0   ]
                [   sin(theta)     cos(theta)    0   ]
                [       0              0         1   ]

  Rotating with a positive angle theta rotates points on the positive x axis toward the positive y axis.

  Specified by:
    `rotate` in class `Graphics2D`
  Parameters:
    `theta` - the angle of rotation in radians

### rotate

    public void rotate(double theta,
                       double x,
                       double y)

  Concatenates the current `Graphics2D` `Transform` with a translated rotation transform. Subsequent rendering is transformed by a transform which is constructed by translating to the specified location, rotating by the specified radians, and translating back by the same amount as the original translation. This is equivalent to the following sequence of calls:

                translate(x, y);
                rotate(theta);
                translate(-x, -y);

  Rotating with a positive angle theta rotates points on the positive x axis toward the positive y axis.

  Specified by:
    `rotate` in class `Graphics2D`
  Parameters:
    `theta` - the angle of rotation in radians
    `x` - the x coordinate of the origin of the rotation
    `y` - the y coordinate of the origin of the rotation

### scale

    public void scale(double sx,
                      double sy)

  Concatenates the current `Graphics2D` `Transform` with a scaling transformation Subsequent rendering is resized according to the specified scaling factors relative to the previous scaling. This is equivalent to calling `transform(S)`, where S is an `AffineTransform` represented by the following matrix:

                [   sx   0    0   ]
                [   0    sy   0   ]
                [   0    0    1   ]

  Specified by:
    `scale` in class `Graphics2D`
  Parameters:
    `sx` - the amount by which X coordinates in subsequent rendering operations are multiplied relative to previous rendering operations.
    `sy` - the amount by which Y coordinates in subsequent rendering operations are multiplied relative to previous rendering operations.

### shear

    public void shear(double shx,
                      double shy)

  Concatenates the current `Graphics2D` `Transform` with a shearing transform. Subsequent renderings are sheared by the specified multiplier relative to the previous position. This is equivalent to calling `transform(SH)`, where SH is an `AffineTransform` represented by the following matrix:

                [   1   shx   0   ]
                [  shy   1    0   ]
                [   0    0    1   ]

  Specified by:
    `shear` in class `Graphics2D`
  Parameters:
    `shx` - the multiplier by which coordinates are shifted in the positive X axis direction as a function of their Y coordinate
    `shy` - the multiplier by which coordinates are shifted in the positive Y axis direction as a function of their X coordinate

### transform

    public void transform(AffineTransform Tx)

  Composes an `AffineTransform` object with the `Transform` in this `Graphics2D` according to the rule last-specified-first-applied. If the current `Transform` is Cx, the result of composition with Tx is a new `Transform` Cx'. Cx' becomes the current `Transform` for this `Graphics2D`. Transforming a point p by the updated `Transform` Cx' is equivalent to first transforming p by Tx and then transforming the result by the original `Transform` Cx. In other words, Cx'(p) = Cx(Tx(p)). A copy of the Tx is made, if necessary, so further modifications to Tx do not affect rendering.

  Specified by:
    `transform` in class `Graphics2D`
  Parameters:
    `Tx` - the `AffineTransform` object to be composed with the current `Transform`
  See Also:
    `setTransform(java.awt.geom.AffineTransform)`, `AffineTransform`

### setTransform

    public void setTransform(AffineTransform Tx)

  Sets the `Transform` in the `Graphics2D` context.

  Specified by:
    `setTransform` in class `Graphics2D`
  Parameters:
    `Tx` - the `AffineTransform` object to be used in the rendering process
  See Also:
    `transform(java.awt.geom.AffineTransform)`, `AffineTransform`

### getTransform

    public AffineTransform getTransform()

  Returns a copy of the current `Transform` in the `Graphics2D` context.

  Specified by:
    `getTransform` in class `Graphics2D`
  Returns:
    the current `AffineTransform` in the `Graphics2D` context.
  See Also:
    `transform(java.awt.geom.AffineTransform)`, `setTransform(java.awt.geom.AffineTransform)`

### getPaint

    public Paint getPaint()

  Returns the current `Paint` of the `Graphics2D` context.

  Specified by:
    `getPaint` in class `Graphics2D`
  Returns:
    the current `Graphics2D` `Paint`, which defines a color or pattern.
  See Also:
    `setPaint(java.awt.Paint)`, `Graphics.setColor(java.awt.Color)`

### getComposite

    public Composite getComposite()

  Returns the current `Composite` in the `Graphics2D` context.

  Specified by:
    `getComposite` in class `Graphics2D`
  Returns:
    the current `Graphics2D` `Composite`, which defines a compositing style.
  See Also:
    `setComposite(java.awt.Composite)`

### setBackground

    public void setBackground(Color color)

  Sets the background color for the `Graphics2D` context. The background color is used for clearing a region. When a `Graphics2D` is constructed for a `Component`, the background color is inherited from the `Component`. Setting the background color in the `Graphics2D` context only affects the subsequent `clearRect` calls and not the background color of the `Component`. To change the background of the `Component`, use appropriate methods of the `Component`.

  Specified by:
    `setBackground` in class `Graphics2D`
  Parameters:
    `color` - the background color that isused in subsequent calls to `clearRect`
  See Also:
    `getBackground()`, `Graphics.clearRect(int, int, int, int)`

### getBackground

    public Color getBackground()

  Returns the background color used for clearing a region.

  Specified by:
    `getBackground` in class `Graphics2D`
  Returns:
    the current `Graphics2D` `Color`, which defines the background color.
  See Also:
    `setBackground(java.awt.Color)`

### getStroke

    public Stroke getStroke()

  Returns the current `Stroke` in the `Graphics2D` context.

  Specified by:
    `getStroke` in class `Graphics2D`
  Returns:
    the current `Graphics2D` `Stroke`, which defines the line style.
  See Also:
    `setStroke(java.awt.Stroke)`

### clip

    public void clip(Shape s)

  Intersects the current `Clip` with the interior of the specified `Shape` and sets the `Clip` to the resulting intersection. The specified `Shape` is transformed with the current `Graphics2D` `Transform` before being intersected with the current `Clip`. This method is used to make the current `Clip` smaller. To make the `Clip` larger, use `setClip`. The user clip modified by this method is independent of the clipping associated with device bounds and visibility. If no clip has previously been set, or if the clip has been cleared using `setClip` with a `null` argument, the specified `Shape` becomes the new user clip.

  Specified by:
    `clip` in class `Graphics2D`
  Parameters:
    `s` - the `Shape` to be intersected with the current `Clip`. If `s` is `null`, this method clears the current `Clip`.

### getFontRenderContext

    public FontRenderContext getFontRenderContext()

  Get the rendering context of the `Font` within this `Graphics2D` context. The `FontRenderContext` encapsulates application hints such as anti-aliasing and fractional metrics, as well as target device specific information such as dots-per-inch. This information should be provided by the application when using objects that perform typographical formatting, such as `Font` and `TextLayout`. This information should also be provided by applications that perform their own layout and need accurate measurements of various characteristics of glyphs such as advance and line height when various rendering hints have been applied to the text rendering.

  Specified by:
    `getFontRenderContext` in class `Graphics2D`
  Returns:
    a reference to an instance of FontRenderContext.
  Since:
    JDK1.2
  See Also:
    `FontRenderContext`, `Font.createGlyphVector(FontRenderContext,char[])`, `TextLayout`

### getGraphicContext

    public GraphicContext getGraphicContext()

  Returns:
    the `GraphicContext` of this `Graphics2D`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| xmlgraphics-commons 1.5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 1999-2012 The Apache Software Foundation. All Rights Reserved.